# Ring ノートパットアプリケーション (RNote)
# 原作者 : Mahmoud Fayed <msfclipper@yahoo.com>

class RNoteLists 

	# qStringList へ Ring のリストを追加する関数を作成します
	func AddItems aList,oList
		for Item in aList
			oList.Append(Item)
		next


	func DisplayFunctionsList
		oFunctionsList.clear()
		if oDockFunctionsList.isvisible() = false return ok
		aFunctionsPos = []	# Lines numbers for each function
		if cActiveFileName = NULL return ok
		cTempActiveFile = cActiveFileName
		# Set the font
			oTFont.fromstring(cFont)
			oFunctionsList.setFont(oTFont)
		StatusMessage("関数のリストを作成しています ... しばらくお待ちください！")
		aFileContent = str2list(read(FileNameEncoding(cActiveFileName)))
		nLineNumber = 0
		for cLine in aFileContent
			nLineNumber++
			cLine = lower(trim(cLine))
			if ( substr(cLine,"func ") > 0 ) or ( substr(cLine,"def ") > 0 )
				cLine = substr(cLine,"("," (")
				aList = Split(cLine," ")
				if len(aList) >= 2
					cFuncName = lower(trim(aList[2]))
					cFuncNameWithoutSymbols = cFuncName
					for cChar in ["_","@","$"]
						cFuncNameWithoutSymbols = substr(cFuncNameWithoutSymbols,cChar,"")
					next 
					if isalnum(cFuncNameWithoutSymbols) and 
						( lower(trim(aList[1])) = "func" or lower(trim(aList[1])) = "def" )
						aFunctionsPos + [cFuncName+"()" , nLineNumber]
					ok
				ok
			ok
			if nLineNumber % 100 = 0 
				nOldCount = oFunctionsList.Count()
				oApp.ProcessEvents()
				if oFunctionsList.Count() != nOldCount 
					return
				ok
				# ファイルの変更を確認
				if not cTempActiveFile = cActiveFileName
					return 
				ok
			ok
		next
		aFunctionsPos = Sort(aFunctionsPos,1)
		for cFunc in aFunctionsPos
			oFunctionsList.addItem(cFunc[1])
		next
		oDockFunctionsList.setWindowTitle("関数 ("+oFunctionsList.Count()+")")
		StatusMessage("関数のリストを作成しています ... 完了！")

	func SelectFunction
		nIndex = oFunctionsList.currentrow() + 1
		nLine = aFunctionsPos[nIndex][2]
		gotoline(nLine)
		oDockSourceCode.Raise()

	func DisplayClassesList
		oClassesList.clear()
		if oDockClassesList.isvisible() = false return ok
		aClassesPos = []	# Lines numbers for each class
		if cActiveFileName = NULL return ok
		cTempActiveFile = cActiveFileName
		# Set the font
			oTFont.fromstring(cFont)
			oClassesList.setFont(oTFont)
		StatusMessage("クラスのリストを作成しています ... しばらくお待ちください！")
		aFileContent = str2list(read(FileNameEncoding(cActiveFileName)))
		nLineNumber = 0
		for cLine in aFileContent
			nLineNumber++
			cLine = lower(trim(cLine))
			if substr(cLine,"class ") > 0
				aList = Split(cLine," ")
				if len(aList) >= 2
					cClassName = lower(trim(aList[2]))
					if lower(trim(aList[1])) = "class"
						aClassesPos + [cClassName , nLineNumber]
					ok
				ok
			ok
			if nLineNumber % 100 = 0 
				nOldCount = oClassesList.Count()
				oApp.ProcessEvents()
				if oClassesList.Count() != nOldCount 
					return 
				ok
				# ファイルの変更を確認
				if not cTempActiveFile = cActiveFileName
					return 
				ok
			ok
		next
		aClassesPos = Sort(aClassesPos,1)
		for cClass in aClassesPos
			oClassesList.addItem(cClass[1])
		next
		oDockClassesList.setWindowTitle("クラス ("+oClassesList.Count()+")")
		StatusMessage("クラスのリストを作成しています ... 完了！")

	func SelectClass
		nIndex = oClassesList.currentrow() + 1
		nLine = aClassesPos[nIndex][2]
		gotoline(nLine)
		oDockSourceCode.Raise()
