//
// plain-text to tmx converter
//
// 2021/05/02 : first prototype.

xml_version               = '1.0'
xml_encoding              = "UTF-8"
tmx_version               = '1.4'

// Header section.
tmx_creation_tool         = "text2tmx by isVowel"
tmx_creation_tool_version = '0.01'
tmx_datatype              = :plaintext
tmx_segtype               = :sentence
tmx_filewriter            = 'Ring 1.14 for Windows by Ring Team'
tmx_adminlang             = :en
tmx_srclang               = :en
tmx_creationid            = :text2tmx
//tmx_creationid            = sysget(:username)

// tuv section.
tuv_source_language       = 'EN-US'
tuv_target_language       = 'JA'

// alias for time() function
T_YEAR  = 19
T_MONTH = 10
T_DAYS  =  6
T_HOUR  =  7
T_MIN   = 11
T_SEC   = 13


// XML escape charactors
escape_map = [
	[	`&` ,	`&amp;`	],		// Do not change order.
	[	`"` ,	`&quot;`],
	[	`'` ,	`&apos;`],
	[	`<` ,	`&lt;`	],
	[	`>` ,	`&gt;`	]
]


// TODO: R}hC̎擾

def main()

	// : XNvgs\t@CɂƂ sysargv ̋قȂ (C@ ringpm  getpara.ring Q)B
	if len(sysargv) < 4
		? ""
		? "Syntax: txt2tmx [source_text] [target_text]"
		return
	ok

	if (fexists(sysargv[3]) = false)

		? "Error: Souece file not found: " + sysargv[3]
		return

	but (fexists(sysargv[4]) = false)

		? "Error: Target file not found : " + sysargv[4]
		return

	ok




	source_list = readfile2list(sysargv[3])
	target_list = readfile2list(sysargv[4])

//	source_list = readfile2list("x.txt")
//	target_list = readfile2list("x.txt")

	tmx_header()

	for i = 1 to len(source_list)
		tuv_print(source_list[i], target_list[i])

//		? source_list[i]
	next

	tmx_footer()

end


// TODO: dڂ̏@\
def uniq_list ()
end





def readfile2list(filename)
	return str2list( xml_escape( read(filename) ) )


def creation_time()
	source_time = timelist()
	return	source_time[T_YEAR] + source_time[T_MONTH] + source_time[T_DAYS] + "T" +
			source_time[T_HOUR] + source_time[T_MIN  ] + source_time[T_SEC ] + "Z"


def xml_escape(text)
	for i = 1 to len(escape_map)
		text = substr(text, escape_map[i][1],    escape_map[i][2])
	next
	return text


def tuv_print(source_text, target_text)
	if (source_text = " ") and (target_text = " ")	// Igrone that empty line (not NULL).
		return
	ok

	if (source_text = "") and (target_text = "")	// Igrone that empty line (not NULL).
		return
	ok

	? TAB + '<tu>'
	? TAB + TAB + '<tuv lang="' + tuv_source_language +     '">'
	? TAB + TAB + TAB + '<seg>' +  source_text        + '</seg>'
	? TAB + TAB + '</tuv>'
	? TAB + TAB + '<tuv lang="' + tuv_target_language +
			 '" changedate="'   + creation_time()     +
			 '" creationid="'   + tmx_creationid      +
			 '" creationdate="' + creation_time()     +     '">'
	? TAB + TAB + TAB + '<seg>' + target_text         + '</seg>'
	? TAB + TAB + '</tuv>'
	? TAB + '</tu>'


def tmx_header()
	? '<?xml version="'          + xml_version               + '" encoding="' + xml_encoding + '"?>'
	? '<tmx version="'           + tmx_version               +                                 '">'

	? TAB + '<header '           +
		 'creationtool="'        + tmx_creation_tool         + '" ' +
		 'creationtoolversion="' + tmx_creation_tool_version + '" ' +
		 'o-tmf="'               + tmx_filewriter            + '" ' +
		 'datatype="'            + tmx_datatype              + '" ' +
		 'segtype="'             + tmx_segtype               + '" ' +
		 'adminlang="'           + tmx_adminlang             + '" ' +
		 'srclang="'             + tmx_srclang               + '" ' +
		 'creationdate="'        + creation_time()           + '" ' +
		 'creationid="'          + tmx_creationid            +
	'" />'

	? TAB + '<body>'


def tmx_footer()
	? TAB + "</body>"
	? "</tmx>"

